﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;
using System.Windows.Controls;

namespace AGV_WPF.Models
{
    public class AgvMember
    {
        public string txtAGVNum { get; set; }
        public string txtWL { get; set; }
        public string txtTrafficNum { get; set; }
        public string txtTrafficNumList { get; set; }
        public string txtTrafficState { get; set; }
        public string txtStatus { get; set; }
        public string txtWorkLine { get; set; }
        public string txtLineNum { get; set; }
        public string txtMarkNum { get; set; }
        public string txtMarkFunction { get; set; }
        public string txtSpeed { get; set; }
        public string txtDockNum { get; set; }
        public string txtAgvAlias { get; set; }//AGV别名
        public string txtVoltage { get; set; }
        public string txtCurrent { get; set; }
        public string txtTemperature { get; set; }
        public string txtLoadingStatus { get; set; }
        public Label AgvLabel;
        public Image AgvImage;
        public string txtTrafficAgv { get; set; }
        public string txtTrafficAgvList { get; set; }
        public string txtOffLineCount { get; set; }//掉线计数
        public string txtIsMainAgv { get; set; }

        public AgvMember()
        {
            txtAGVNum = "AGV?";
            txtAgvAlias = "AGV?";
            txtWL = "失败";
            txtTrafficNum = "0";
            txtTrafficNumList = "0";
            txtTrafficState = "初始化...";
            txtTrafficAgv = "无";
            txtTrafficAgvList = "无";
            txtStatus = "初始化...";
            txtWorkLine = "0";
            txtLineNum = "0";
            txtMarkNum = "0";
            txtMarkFunction = "初始化...";
            txtSpeed = "初始化...";
            txtDockNum = "0";
            txtOffLineCount = "0";
            txtVoltage = "0";
            txtCurrent = "0";
            txtTemperature = "0";
            txtLoadingStatus = "空车";
            txtIsMainAgv = "无效";
        }

        public string txtAgvAliasValue
        {
            get { return txtAgvAlias; }
            set 
            {
                if (value != this.txtAgvAlias)
                {
                    txtAgvAlias = value;
                }
            }
        }
        
        public string txtTrafficAgvValue
        {
            get { return txtTrafficAgv; }
            set 
            {
                if (value != this.txtTrafficAgv)
                {
                    txtTrafficAgv = value;
                }
            }
        }
        public string txtTrafficAgvListValue
        {
            get { return txtTrafficAgvList; }
            set
            {
                if (value != this.txtTrafficAgvList)
                {
                    txtTrafficAgvList = value;
                }
            }
        }
        public string txtOffLineCountValue
        {
            get { return txtOffLineCount; }
            set
            {
                if (value != this.txtOffLineCount)
                {
                    txtOffLineCount = value;
                }
            }
        }
        public string txtAGVNumValue
        {
            get { return this.txtAGVNum; }
            set
            {
                if (value != this.txtAGVNum)
                {
                    this.txtAGVNum = value;
                }
            }
        }

        public string txtWLValue
        {
            get { return this.txtWL; }
            set
            {
                if (value != this.txtWL)
                {
                    this.txtWL = value;
                }
            }
        }

        public string txtTrafficNumValue
        {
            get { return this.txtTrafficNum; }
            set
            {
                if (value != this.txtTrafficNum)
                {
                    this.txtTrafficNum = value;
                }
            }
        }
        public string txtTrafficNumListValue
        {
            get { return this.txtTrafficNumList; }
            set
            {
                if (value != this.txtTrafficNumList)
                {
                    this.txtTrafficNumList = value;
                }
            }
        }
        public string txtTrafficStateValue
        {
            get { return this.txtTrafficState; }
            set
            {
                if (value != this.txtTrafficState)
                {
                    this.txtTrafficState = value;
                }
            }
        }

        public string txtStatusValue
        {
            get { return this.txtStatus; }
            set
            {
                if (value != this.txtStatus)
                {
                    this.txtStatus = value;
                }
            }
        }

        public string txtWorkLineValue
        {
            get { return this.txtWorkLine; }
            set
            {
                if (value != this.txtWorkLine)
                {
                    this.txtWorkLine = value;
                }
            }
        }

        public string txtLineNumValue
        {
            get { return this.txtLineNum; }
            set
            {
                if (value != this.txtLineNum)
                {
                    this.txtLineNum = value;
                }
            }
        }

        public string txtMarkNumValue
        {
            get { return this.txtMarkNum; }
            set
            {
                if (value != this.txtMarkNum)
                {
                    this.txtMarkNum = value;
                }
            }
        }

        public string txtMarkFunctionValue
        {
            get { return this.txtMarkFunction; }
            set
            {
                if (value != this.txtMarkFunction)
                {
                    this.txtMarkFunction = value;
                }
            }
        }

        public string txtSpeedValue
        {
            get { return this.txtSpeed; }
            set
            {
                if (value != this.txtSpeed)
                {
                    this.txtSpeed = value;
                }
            }
        }

        public string txtDockNumValue
        {
            get { return this.txtDockNum; }
            set
            {
                if (value != this.txtDockNum)
                {
                    this.txtDockNum = value;
                }
            }
        }
        public string txtVoltageValue
        {
            get { return this.txtVoltage; }
            set
            {
                if (value != this.txtVoltage)
                {
                    this.txtVoltage = value;
                }
            }
        }
        public string txtCurrentValue
        {
            get { return this.txtCurrent; }
            set
            {
                if (value != this.txtCurrent)
                {
                    this.txtCurrent = value;
                }
            }
        }
        public string txtTemperatureValue
        {
            get { return this.txtTemperature; }
            set
            {
                if (value != this.txtTemperature)
                {
                    this.txtTemperature = value;
                }
            }
        }
        public string txtLoadingStatusValue
        {
            get { return this.txtLoadingStatus; }
            set
            {
                if (value != this.txtLoadingStatus)
                {
                    this.txtLoadingStatus = value;
                }
            }
        }
        public string txtIsMainAgvValue
        {
            get { return this.txtIsMainAgv; }
            set
            {
                if (value != this.txtIsMainAgv)
                {
                    this.txtIsMainAgv = value;
                }
            }
        }

        
        /// <summary>
        /// Dispose resources
        /// </summary>
        public void Dispose()
        {
            // This object will be cleaned up by the Dispose method.
            GC.SuppressFinalize(this);
        }


    }
}
