﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using AGV_WPF.Plugin;


namespace TrafficDll
{
    class TrafficArea
    {
        public int[] PointArr;
        public int[] PointArrOut;
        public int[] PointArrInside;
        public byte TypeTraffic;
        public int Number;              //管制区号
        public bool Status;  			//0空闲 1忙
        public AGV_WPF.MainWindow.AGVStatus_TypStr OccupyAgv; 			//占用车辆编号
        public List<AGV_WPF.MainWindow.AGVStatus_TypStr> WaitAgv;          //排队等待区车辆
        public byte ReadIndex;  		//排队车辆运行到哪一辆
        public byte WriteIndex; 	//	//排队车辆排到的具体位置       
       // public WorkMarkStr[] WorkMark;  //定义地标所在流水线号和地标号
       // public byte RelationArea;       //从管制区
        public TrafficArea()
        {
             PointArr=new int[]{};
             PointArrOut = new int[] { };
             PointArrInside = new int[] { };
             TypeTraffic = 0;       //0表示管制双向  1表示管制前进  2表示管制后退
             Number=0;              //管制区号
             Status= false;		//0空闲 1忙
             OccupyAgv = new AGV_WPF.MainWindow.AGVStatus_TypStr(); 			//占用车辆编号
             WaitAgv = new List<AGV_WPF.MainWindow.AGVStatus_TypStr>();          //排队等待区车辆
             ReadIndex=0;  		//排队车辆运行到哪一辆
             WriteIndex=0; 	//	//排队车辆排到的具体位置   
        }

    }
}
