//#define TEST
using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Threading;
namespace Tools
{
    public class CBlackBoxFile
    {
        private static readonly int FILE_LENGTH = 1024*100;//100K
        private static readonly int FILE_BACK_LENGTH = 1024*1024;//1M,Ըʵ
        private static readonly int MAX_NUMBER_FILE = 3;//ļĸ+1Ϊ4
        private static readonly string strDir = System.IO.Directory.GetCurrentDirectory() + "\\MyFile";
        private static readonly string strBakDir = System.IO.Directory.GetCurrentDirectory() + "\\MyBakFile";
        public List<string> mFileList = new List<string>();
        private  static Mutex m_MutexSection=new Mutex ();

        public CBlackBoxFile() 
        {
                    
        }
       /// <summary>
       /// ϻӼ¼
       /// </summary>
       /// <param name="uFileName">ļı</param>
       /// <param name="fileContext">Ҫ¼Ϣ</param>
        public void WriteFile(ushort uFileName, string fileContext)
        {
            fileContext = DateTime.Now.ToString()+": " + fileContext;
            DirectoryInfo dir = new DirectoryInfo(strDir);
            if (!dir.Exists)
            {
                CreateDir(strDir);
            }
            string strFileName = uFileName + ".txt";
            string fname = strDir + "\\" + strFileName;
            FileInfo finfo = new FileInfo(fname);       
            if (finfo.Exists && finfo.Length > FILE_LENGTH)
            {
                //ļ
                m_MutexSection.WaitOne();
                DirectoryInfo dirBak = new DirectoryInfo(strBakDir);
                if (!dirBak.Exists)
                {
                    CreateDir(strBakDir);
                }
                ///ɾļ 
                try
                {                  
                    //ݴ
#if TEST
#else
                    string strText = File.ReadAllText(fname);
                    strText += fileContext;//ϸ֡
                    DelBakFile(MAX_NUMBER_FILE, uFileName, strText);
#endif
                    File.WriteAllText(fname, "");
                }
                catch (Exception ex)
                {
                    Console.WriteLine(ex.ToString ());
                }
                m_MutexSection.ReleaseMutex();
                //жϱݼǷNɾһٱ
            }
            else
            {
                try
                {
                    //ڣļд
                    if (!finfo.Exists)
                    {
                        CreateMyFile(uFileName, fileContext);
                    }
                    //Ļ׷
                    else
                    {
                        AppendMyText(uFileName, fileContext);
                    }
                }
                catch (Exception ex) 
                {
                    Console.WriteLine(ex.ToString());
                }
            }            
        }

        //ļ
        /// <summary>
        /// µļ
        /// </summary>
        /// <param name="uFileName">ļ</param>
        /// <param name="fileContext">Ҫ¼Ϣ</param>
        private  void CreateMyFile(ushort uFileName, string fileContext)
        {
            m_MutexSection.WaitOne();
            FileInfo fi = new FileInfo(strDir + "\\" + uFileName + ".txt");
            //д
            StreamWriter w = fi.CreateText();           
            w.WriteLine(fileContext);
            w.Close();
            m_MutexSection.ReleaseMutex(); 

        }      
        /// <summary>
        /// ׷Ϣ
        /// </summary>
        /// <param name="uFileName">ļı</param>
        /// <param name="fileContext">Ҫ¼Ϣ</param>
        private void AppendMyText(ushort uFileName, string fileContext)
        {
            m_MutexSection.WaitOne();
            try
            {
                FileInfo fi = new FileInfo(strDir + "\\" + uFileName + ".txt");
                StreamWriter w = fi.AppendText();
                w.WriteLine(fileContext);
                w.Close();
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.ToString ());                
            }
            m_MutexSection.ReleaseMutex();
        }

        /// <summary>
        /// ȡϵͳʱ
        /// </summary>
        /// <returns>ϵͳʱı</returns>
        private string GetSysTime()
        {
            string timeFileName = "";
            timeFileName = DateTime.Now.Year.ToString();
            if (int.Parse(DateTime.Now.Month.ToString()) < 10)
            {
                timeFileName += "0" + DateTime.Now.Month.ToString();
            }
            else
            {
                timeFileName += DateTime.Now.Month.ToString();
            }

            if (int.Parse(DateTime.Now.Day.ToString()) < 10)
            {
                timeFileName += "0" + DateTime.Now.Day.ToString();
            }
            else
            {
                timeFileName += DateTime.Now.Day.ToString();
            }

            if (int.Parse(DateTime.Now.Hour.ToString()) < 10)
            {
                timeFileName += "0" + DateTime.Now.Hour.ToString();
            }
            else
            {
                timeFileName += DateTime.Now.Hour.ToString();
            }

            if (int.Parse(DateTime.Now.Minute.ToString()) < 10)
            {
                timeFileName += "0" + DateTime.Now.Minute.ToString();
            }
            else
            {
                timeFileName += DateTime.Now.Minute.ToString();
            }
            if (int.Parse(DateTime.Now.Second.ToString()) < 10)
            {
                timeFileName += "0" + DateTime.Now.Second.ToString();
            }
            else
            {
                timeFileName += DateTime.Now.Second.ToString();
            }

            return timeFileName;
           
           
        }

        //Ŀ¼
        private void CreateDir(string directory)
        {
            DirectoryInfo dirInfo = new DirectoryInfo(directory);
            dirInfo.Create();
        }

        //жϱļǷNɾһٱ
        private void DelBakFile(int n,ushort ID,string strText)
        {
            mFileList.Clear();

            string strPathFile = strBakDir+"\\";
            int bakFileNum = GetBakFileNum(ID);

            mFileList.Sort();            

            if (bakFileNum > n)
            {
                string strMax = strPathFile + mFileList[bakFileNum - 1];

                FileInfo finfo = new FileInfo(strMax);

                if (finfo.Length > FILE_BACK_LENGTH)
                {
                    strPathFile += mFileList[0];

                    FileInfo firBakFile = new FileInfo(strPathFile);

                    firBakFile.Delete();                   

                    DelBakFile(n,ID,strText);
                }
                else 
                {
                    strPathFile += mFileList[bakFileNum - 1];

                    File.AppendAllText(strPathFile, strText);
                }
            }
            else if (bakFileNum==0)
            {              

                string bakName = strBakDir+"\\";

                bakName += GetSysTime();
                bakName += "_" + ID;
                bakName += "_";
                bakName += ".txt";

                FileInfo fi = new FileInfo(bakName);
                //д
                StreamWriter w = fi.CreateText();  
              
                w.Write(strText);

                w.Close();

                
            }
            else if (bakFileNum > 0 && bakFileNum<=n) 
            {
                string strMax = strPathFile + mFileList[bakFileNum - 1];

                FileInfo finfo = new FileInfo(strMax);

                if (finfo.Length > FILE_BACK_LENGTH)
                {
                    string bakName = strBakDir + "\\";

                    bakName += GetSysTime();

                    bakName += "_" + ID;
                    bakName += "_";
                    bakName += ".txt";

                    FileInfo firBakFile = new FileInfo(bakName);

                    StreamWriter w = firBakFile.CreateText();

                    w.Write(strText);

                    w.Close();
                }
                else 
                {
                    File.AppendAllText(strMax, strText);
                }
            }
        }

        //ñļ
        private int GetBakFileNum(ushort ID)
        {
            int n = 0;
            DirectoryInfo dirInfo = new DirectoryInfo(strBakDir);
            string str = "_" + ID.ToString()+"_";
            foreach (FileSystemInfo fsi in dirInfo.GetFileSystemInfos())
            {
                if (fsi is FileInfo && fsi.Extension == ".txt")
                {
                    if (fsi.Name.Contains(str))
                    {
                        mFileList.Add(fsi.Name);
                        n++;
                    }
                }
            }
            return n;
        }
    }
}
