﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace AGV_WPF
{
    /// <summary>
    /// TrafficManageNew.xaml 的交互逻辑
    /// </summary>
    public partial class TrafficManageNew : Window
    {
        public TrafficManageNew()
        {
            InitializeComponent();
        }
        public DAL.ZSql sql1 = new DAL.ZSql();

        /// <summary>
        /// 添加
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnAdd_Click(object sender, RoutedEventArgs e)
        {
            //string strcarid = tbCarID.Text.ToString().Trim();
            string tafficNum = Tb_Number.Text.ToString();
            string point = Tb_Point.Text.ToString();
            string pointInside = Tb_PointInside.Text.ToString();
            string pointOutside = Tb_PointOutside.Text.ToString();
            string typeTraffic = Tb_Type.Text.ToString();
            if (string.IsNullOrEmpty(tafficNum))
            {
                //MessageBox.Show("对不起，请同时输入生产区和小车编号！");
                MessageBox.Show("the traffic number can not be null");
                return;
            }
            sql1.Open("select * from T_TrafficNew where TrafficAreaNum=" + tafficNum);
            if (sql1.Rows.Count > 0)
            {
                MessageBox.Show("the traffic number has existed！");
              //  MessageBox.Show(App.m_language.GetCtrlValue("ThisAgvIsExist", "此AGV已经存在！"));
                return;
            }
            else
            {
                string a = " insert into T_TrafficNew (TrafficAreaNum,PointList,PointInsideList,PointOutsideList,TypeTraffic) Values ('" + tafficNum + "','" + point + "','" + pointInside + "','" + pointOutside + "','" + typeTraffic + "')";
                sql1.Open("insert into T_TrafficNew (TrafficAreaNum,PointList,PointInsideList,PointOutsideList,TypeTraffic) Values ('" + tafficNum + "','" + point + "','" + pointInside + "','" + pointOutside + "','" + typeTraffic + "')");
                //MessageBox.Show("添加AGV生产区成功！");
                //MessageBox.Show(App.m_language.GetCtrlValue("AddSuccessed", "添加成功！"));
            }
            sql1.Close();
            LoadDataGrid();
        }

        /// <summary>
        /// 修改
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnModify_Click(object sender, RoutedEventArgs e)
        {
            string tafficNum = Tb_Number.Text.ToString();
            string point = Tb_Point.Text.ToString();
            string pointInside = Tb_PointInside.Text.ToString();
            string pointOutside = Tb_PointOutside.Text.ToString();
            string typeTraffic = Tb_Type.Text.ToString();
            if (string.IsNullOrEmpty(tafficNum) || string.IsNullOrEmpty(point) )
            {
                MessageBox.Show("some message can not be null！");
               // MessageBox.Show(App.m_language.GetCtrlValue("InputGenerativeAreaAgvId", "对不起，请同时输入生产区和小车编号！"));
                return;
            }
            sql1.Open("select * from T_TrafficNew where TrafficAreaNum=" + tafficNum);
            if (sql1.Rows.Count == 0)
            {
                MessageBox.Show("the traffic is not existed");
               // MessageBox.Show(App.m_language.GetCtrlValue("ThisAgvIsNotExist", "此AGV不存在！"));
                return;
            }
            else
            {
               
               // sql1.Open("insert into T_TrafficNew (TrafficAreaNum,PointList,PointInsideList,PointOutsideList) Values (" + tafficNum + "," + point + "," + pointInside + "," + pointOutside + ")");
                sql1.Open("update T_TrafficNew set PointList='" + point + "', PointInsideList='" + pointInside + "', PointOutsideList='" + pointOutside + "', TypeTraffic='" + typeTraffic + "' where TrafficAreaNum=" + tafficNum);
                MessageBox.Show("Successful！");
                //MessageBox.Show(App.m_language.GetCtrlValue("UpdateSuccessed", "修改稿成功！"));
            }
            sql1.Close();
            sql1.Dispose();
            LoadDataGrid();
        }

        /// <summary>
        /// 删除
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void bttnDelete_Click(object sender, RoutedEventArgs e)
        {
            string tafficNum = Tb_Number.Text.ToString();
            string point = Tb_Point.Text.ToString();
            string pointInside = Tb_PointInside.Text.ToString();
            string pointOutside = Tb_PointOutside.Text.ToString();
            if (string.IsNullOrEmpty(tafficNum))
            {
                MessageBox.Show("some message can not be null！");
                //MessageBox.Show(App.m_language.GetCtrlValue("SelectDeleteAgvId", "对不起，请选择删除AGV编号！"));
                return;
            }
            sql1.Open("select * from T_TrafficNew where TrafficAreaNum=" + tafficNum);
            if (sql1.Rows.Count == 0)
            {
                MessageBox.Show("the traffic is not existed");
                //MessageBox.Show(App.m_language.GetCtrlValue("ThisAgvIsNotExist", "此AGV不存在！"));
                return;
            }
            else
            {
                sql1.Open("delete from T_TrafficNew" + " where TrafficAreaNum=" + tafficNum);
                //MessageBox.Show("删除AGV生产区成功！");
                MessageBox.Show("DeleteSuccessed", "删除成功！");
            }
            sql1.Close();
            LoadDataGrid();
        }
        private void LoadDataGrid()
        {
            sql1 = new DAL.ZSql();
            sql1.Open("select * from T_TrafficNew ");
            dataGrid1.ItemsSource = sql1.m_table.DefaultView;
           
            sql1.Close();
        }

        private void Bt_Read_Click(object sender, RoutedEventArgs e)
        {
            LoadDataGrid();
        }

        private void dataGrid1_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            System.Data.DataRowView selectItem = dataGrid1.SelectedItem as System.Data.DataRowView;
            if (selectItem != null)
            {
                Tb_Number.Text = selectItem["TrafficAreaNum"].ToString().Trim();
                Tb_Point.Text = selectItem["PointList"].ToString().Trim();
                Tb_PointInside.Text = selectItem["PointInsideList"].ToString().Trim();
                Tb_PointOutside.Text = selectItem["PointOutsideList"].ToString().Trim();
                Tb_Type.Text = selectItem["TypeTraffic"].ToString().Trim();
                 //.Text = selectItem["CmdFunction"].ToString().Trim();
            }
            else
            {
                Tb_Number.Text = null;
                Tb_Point.Text = null;
                Tb_PointInside.Text = null;
                Tb_PointOutside.Text = null;
            }
        }

    }
}
