using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.Reflection;

namespace AGV_WPF
{
    /// <summary>
    /// Help.xaml Ľ߼
    /// </summary>
    public partial class Help : Window
    {
        public Help()
        {
            InitializeComponent();
            label2.Content = "       :AGV-Ver" + AssemblyVersion;
            label1.Content = string.Format("Ʒ:{0}", ProductName);
        }

        public string AssemblyVersion
        {
            get
            {
                return Assembly.GetExecutingAssembly().GetName().Version.ToString();
            }
        }
        public string ProductName
        {
            get
            {
                object[] attributes = Assembly.GetExecutingAssembly().GetCustomAttributes(typeof(AssemblyProductAttribute), false);
                if (attributes.Length == 0)
                {
                    return "";
                }
                return ((AssemblyProductAttribute)attributes[0]).Product;
            }
        }
        /// <summary>
        /// ˾ҳ
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void hyperlinkCompany_Click(object sender, RoutedEventArgs e)
        {
            System.Diagnostics.Process.Start("http://www.casun.cn/");
        }
    }
}
