﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel;

namespace AgvAlarmServiceLibrary
{
    [ServiceContract(CallbackContract=typeof(ISrvToClientCallBack))]
    public interface IAgvAlarmService
    {
        [OperationContract]
        string InitClient();
    }
    public interface ISrvToClientCallBack
    {
        [OperationContract(IsOneWay = true)]
        void NotifyClientAlarm(AlarmInfo info);
        [OperationContract(IsOneWay = true)]
        void NotifyClient(string msg);
    }
}
